#!/usr/bin/perl
#

use Getopt::Std;
use FileHandle;

$PI = 3.14159265357989;

# Input format is 
# name,right ascention (radians),declination (radians),magnitude,spectral type

# Output format is 
$^L="";
format stardata_top =
Star		Data
-------------------------------
.
format stardata =
@<<<<<<<<< @<<<<<<<<< @<<<<<<<< @<<<<<< @<<<<
$name, $ra,$dec,$mag,$type
.

while (<STDIN>) {
        format_name     STDOUT "stardata";
        format_top_name STDOUT "stardata_top";
	if ( /^(.*?),([\-\d\.]+),([\-\d\.]+),([\-\d\.]+),(.*)$/ ) {
		$name = $1;
		$ra = $2;
		$ra = convertdeg_time(convertradians_deg($2));
		$dec = convertdeg_str(convertradians_deg($3));
		$mag =$4;
		$type = $5;
		write;
#		print $name."\t";
#		print convertdeg_time(convertradians_deg($ra))."\t";
#		print convertdeg_time(convertradians_deg($dec))."\t";
#		print $mag."\t";
#		print $type."\t";
	}
}

exit 0;

sub convertdeg_str {
	my ($degrees) = @_;
	my $sign = $degrees / abs ($degrees);
	my $deg = sprintf("%i",$degrees);
	my $string ="";
	$degrees = $degrees * $sign;
	$degrees = ($degrees - $sign * $deg)*60;
	my $min = sprintf("%.2f",$degrees);
#	$degrees = ($degrees - $min) * 60;
#	my $secs = sprintf("%.2f",$degrees);
	$string = "+" if ( $deg > 0 ) ;
	$string = $string.$deg." ".$min;
	return $string;
}
sub convertradians_deg {
	my ($radians) = @_;
	return $radians*180/$PI;
}

sub convertdeg_time {
	my ($degrees) = @_;
	my $time = 3600 * ($degrees / 15);
	my $hour = 0;
	my $min = 0;
	my $secs = 0;
	$hour = sprintf("%i",$time/3600);
	$time = $time - $hour * 3600;
	$min = sprintf("%i",$time/60);
	$time = $time - $min * 60;
	$secs = sprintf("%.2f",$time);
	$localtime = $hour.":".$min.":".$secs;
	return $localtime;
}

sub convertdeg_radians {
	my ($degrees) = @_;
	return $degrees*$PI/180;
}

sub converttime_deg {
	my ($hour,$min,$sec) = @_ ;
	return 0 if $hour < 0 or $hour > 24 or $min < 0 or $min > 60 or $sec < 0 or $sec > 60;
	return 15*($hour+$min/60+$sec/3600);
}
