#!/usr/bin/perl
# Read data generated by Spacechart's gen_spacechart program and 
# output in OU's format
#
# Output format is: 
# name,right ascention (radians),declination (radians),magnitude,spectral type
# 
# Input format is:
# number,catalogue name, short name, x, y, z, ra_hours, ra_minutes, ra_seconds, dec_degrees, dec_minutes

use Getopt::Std;
use FileHandle;

$PI = 3.14159265357989;


while (<STDIN>) {
	if ( /^(.*?),(.*?),/ ) {
	($number,$cat_name, $short_name, $x, $y, $z, $ra_hours, $ra_minutes, $ra_seconds, $dec_degrees, $dec_minutes) = split(/,/);
		$ra = convertdeg_radians(convertra_deg($ra_hours,$ra_minutes,$ra_seconds));
		$dec = convertdeg_radians(convertdec_deg($dec_degrees,$dec_minutes));
		$short_name =~ s/  //g;
		$short_name =~ s/ $//g;
		printf ("%s,%.6f,%.6f\n",$short_name,$ra,$dec) if $ra != 0 && $dec != 0 && $short_name =~ /\w/;
	}
}

exit 0;


sub convertdeg_radians {
	my ($degrees) = @_;
	return $degrees*$PI/180;
}

sub convertra_deg {
	my ($hour,$min,$sec) = @_ ;
	return 0 if $hour < 0 or $hour > 24 or $min < 0 or $min > 60 or $sec < 0 or $sec > 60;
	return 15*($hour+$min/60+$sec/3600);
}

sub convertdec_deg {
	my ($degrees,$minutes) = @_ ;
	return $degrees+$minutes/60;
}
