/*
    replacement for non-free texfont.cpp for openuniverse
    Copyright (C) 2008 PaulLiu(Ying-Chun Liu).

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#ifndef __AVYGDJMW_TEXFONT_H__
#define __AVYGDJMW_TEXFONT_H__

#include <fnt.h>
#include <GL/gl.h>

typedef struct {
  unsigned char width;
  unsigned char height;
  signed char advance;
} TexGlyphInfo;

typedef struct {
  TexGlyphInfo* tgi;
  fntTexFont* plibtexfont;
  fntRenderer* plibrenderer;
} TexFont;

extern TexFont* txfLoadFont(char*);
extern void txfUnloadFont(TexFont*);
extern GLuint txfEstablishTexture(TexFont*,GLuint,GLboolean);
extern void txfBindFontTexture(TexFont*);
extern void txfRenderString(TexFont*,char*,int);

#endif
